Index: code/branches/presentation/data/gui/layouts/AudioMenu.layout
===================================================================
--- code/branches/presentation/data/gui/layouts/AudioMenu.layout	(revision 7770)
+++ code/branches/presentation/data/gui/layouts/AudioMenu.layout	(revision 7779)
@@ -113,5 +113,5 @@
                 <Property Name="Text" >Theme changes might take
 up to a minute.</Property>
-                <Property Name="TextColours" Value="FF4444FF" />
+                <Property Name="TextColours" Value="FFFFFFFF" />
                 <Property Name="InheritsAlpha" Value="False" />
                 <Property Name="HorzFormatting" Value="HorzCentred" />
Index: code/branches/presentation/data/gui/layouts/CreditsMenu.layout
===================================================================
--- code/branches/presentation/data/gui/layouts/CreditsMenu.layout	(revision 7770)
+++ code/branches/presentation/data/gui/layouts/CreditsMenu.layout	(revision 7779)
@@ -32,5 +32,5 @@
                     <Property Name="VertScrollPosition" Value="0" />
                     <Window Type="MenuWidgets/StaticText" Name="orxonox/CreditsText" >
-                        <Property Name="TextColours" Value="FF4444FF" />
+                        <Property Name="TextColours" Value="FFFFFFFF" />
                         <Property Name="InheritsAlpha" Value="False" />
                         <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
@@ -38,5 +38,6 @@
                         <Property Name="VertFormatting" Value="TopAligned" />
                         <Property Name="UnifiedAreaRect" Value="{{0,0},{0,0},{1,0},{1,0}}" />
-                        <Property Name="Text">Orxonox version 0.0.3
+                        <Property Name="Text">wird sowieso nicht gelesen
+Orxonox version 0.0.3
 
 Programming Language:  C++ - lua - tcl
@@ -45,13 +46,5 @@
 
 http://www.orxonox.net
-n
-n
-n
-n
-n
-n
-n
-n
-n                       </Property>
+                      </Property>
                     </Window>
                 </Window>
Index: code/branches/presentation/data/gui/layouts/GraphicsMenu.layout
===================================================================
--- code/branches/presentation/data/gui/layouts/GraphicsMenu.layout	(revision 7770)
+++ code/branches/presentation/data/gui/layouts/GraphicsMenu.layout	(revision 7779)
@@ -15,5 +15,5 @@
             <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
             <Property Name="VertFormatting" Value="TopAligned" />
-            <Property Name="UnifiedAreaRect" Value="{{0.25,0},{0.2875,0},{0.75,0},{0.6375,0}}" />
+            <Property Name="UnifiedAreaRect" Value="{{0.25,0},{0.2,0},{0.75,0},{0.6375,0}}" />
             <Window Type="MenuWidgets/StaticText" Name="orxonox/Resolution" >
                 <Property Name="Text" Value="Resolution" />
@@ -22,9 +22,22 @@
                 <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
                 <Property Name="VertFormatting" Value="TopAligned" />
-                <Property Name="UnifiedAreaRect" Value="{{0.05,0},{0.15,0},{0.475,0},{0.92,0}}" />
+                <Property Name="UnifiedAreaRect" Value="{{0.05,0},{0.10,0},{0.475,0},{0.65,0}}" />
                 <Window Type="MenuWidgets/Listbox" Name="orxonox/ResolutionListbox" >
                     <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-                    <Property Name="UnifiedAreaRect" Value="{{0.05,0},{0.15,0},{0.95,0},{0.95,0}}" />
+                    <Property Name="UnifiedAreaRect" Value="{{0.05,0},{0.2,0},{0.95,0},{0.95,0}}" />
                     <Event Name="ItemSelectionChanged" Function="GraphicsMenu.GraphicsResolutionListbox_changed"/>
+                </Window>
+            </Window>
+            <Window Type="MenuWidgets/StaticText" Name="orxonox/Themes" >
+                <Property Name="Text" Value="Themes" />
+                <Property Name="InheritsAlpha" Value="False" />
+                <Property Name="HorzFormatting" Value="HorzCentred" />
+                <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+                <Property Name="VertFormatting" Value="TopAligned" />
+                <Property Name="UnifiedAreaRect" Value="{{0.525,0},{0.10,0},{0.95,0},{0.35,0}}" />
+                <Window Type="MenuWidgets/Listbox" Name="orxonox/ThemeDropBox" >
+                    <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+                    <Property Name="UnifiedAreaRect" Value="{{0.05,0},{0.3,0},{0.95,0},{0.95,0}" />
+                    <Event Name="ItemSelectionChanged" Function="GraphicsMenu.ThemeDropBox_changed"/>
                 </Window>
             </Window>
@@ -35,5 +48,5 @@
                 <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
                 <Property Name="VertFormatting" Value="TopAligned" />
-                <Property Name="UnifiedAreaRect" Value="{{0.525,0},{0.15,0},{0.95,0},{0.35,0}}" />
+                <Property Name="UnifiedAreaRect" Value="{{0.05,0},{0.70,0},{0.475,0},{0.85,0}}" />
                 <Window Type="MenuWidgets/HorizontalScrollbar" Name="orxonox/BrightnessScrollbar" >
                     <Property Name="Disabled" Value="true" />
@@ -53,5 +66,5 @@
                 <Property Name="Text" Value="Fullscreen" />
                 <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
-                <Property Name="UnifiedAreaRect" Value="{{0.65,0},{0.4,0},{0.85,0},{0.475,0}}" />
+                <Property Name="UnifiedAreaRect" Value="{{0.65,0},{0.35,0},{0.85,0},{0.425,0}}" />
                 <Event Name="CheckStateChanged" Function="GraphicsMenu.GraphicsFullscreenCheckbox_clicked"/>
             </Window>
@@ -61,10 +74,10 @@
 settings require
 a game restart.</Property>
-                <Property Name="TextColours" Value="FF4444FF" />
+                <Property Name="TextColours" Value="FFFFFFFF" />
                 <Property Name="InheritsAlpha" Value="False" />
                 <Property Name="HorzFormatting" Value="HorzCentred" />
                 <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
                 <Property Name="VertFormatting" Value="TopAligned" />
-                <Property Name="UnifiedAreaRect" Value="{{0.525,0},{0.525,0},{0.95,0},{0.92,0}}" />
+                <Property Name="UnifiedAreaRect" Value="{{0.525,0},{0.425,0},{0.95,0},{0.85,0}}" />
             </Window>
         </Window>
Index: code/branches/presentation/data/gui/scripts/GraphicsMenu.lua
===================================================================
--- code/branches/presentation/data/gui/scripts/GraphicsMenu.lua	(revision 7770)
+++ code/branches/presentation/data/gui/scripts/GraphicsMenu.lua	(revision 7779)
@@ -4,4 +4,5 @@
 
 P.buttonList = {}
+P.schemeList = {"TaharezGreen", "Orxonox"}
 
 function P.onShow()
@@ -97,4 +98,27 @@
     }
     P.buttonList[1] = item
+
+    local dropbox = winMgr:getWindow("orxonox/ThemeDropBox")
+    local scheme = orxonox.CommandExecutor:query("getConfig GUIManager guiScheme_")
+    for k,v in pairs(P.schemeList) do
+        local item = CEGUI.createListboxTextItem(P.schemeList[k])
+        item:setSelectionBrushImage(menuImageSet, "MultiListSelectionBrush")
+        CEGUI.toListbox(dropbox):addItem(item)
+        if v == scheme then
+            dropbox:setItemSelectState(item, true)
+        end
+    end
+
+end
+
+function P.ThemeDropBox_changed(e)
+    local dropbox = winMgr:getWindow("orxonox/ThemeDropBox")
+    local listbox = CEGUI.toListbox(dropbox)
+    local choice = listbox:getFirstSelectedItem()
+    local index = 0
+    if choice ~= nil then
+        index = listbox:getItemIndex(choice)
+    end
+    orxonox.CommandExecutor:execute("config GUIManager guiScheme_ " .. P.schemeList[index+1])
 end
 